(function() {
  'use strict';

  var app = {
		registration: null,
		visibleEl: null,
		state: null,

		publicVapidKey: 'BAjGFaPYEOqObLkJr0ToM_S2ZDmi0xNZ6EHwtiVwhEUV7Ji9kgGsXrJOVvrlk2UE2oE4s1jTIvAL3r-vkix7rxs',
		pushAppName: document.querySelector('.header__title').textContent,

		appName: document.querySelector('.header__title').innerHTML,
    isLoading: true,
		daysOfWeek: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
		months: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],

		page: document.querySelector('.container'),
		spinner: document.querySelector('.loader'),
    popupBox: document.querySelector('.dialog-container'),
		fsMsg: document.querySelector('.fs-message'),
		toast: document.querySelector('.toast__container'),
		pwahomescreen: document.querySelector('.pwahomescreen'),
		buttonInstall: document.getElementById('installpwa')
  };

  /*****************************************************************************
   *
   * Functions
   *
   ****************************************************************************/

	app.changeView = function(cls = false, title = false) {
		app.hideMenu();

		// spesific actions for page
		switch (cls) {
			case 'switch-page0':
				cls = false;
				title = false;
				break;
			case 'switch-page1':
				
				break;
			case 'switch-page2':
				
				break;
			case 'switch-page3':
				
				break;
		}

		document.querySelector('.header__title').innerHTML = (title ? title : app.appName);
		app.page.setAttribute('class', 'container');

		if (cls) {
			document.querySelector('#btnHome').style.display = 'block';
			document.querySelector('#btnShare').style.display = 'none';

			app.page.classList.add(cls);
			app.visibleEl = '::' + cls;
		}
		else { // home page view
			document.querySelector('#btnHome').style.display = 'none';
			document.querySelector('#btnShare').style.display = 'block';

			app.visibleEl = '::home';
		}
  };

	app.reloadWebApp = function() {
		document.location.reload();
	};

	app.closeFullscreenMsg = function() {
		app.fsMsg.classList.remove('fs-message--visible');

		// trick to remove all listeners
		var el = app.fsMsg.querySelector('.fsm-footer');
		var elClone = el.cloneNode(true);

		el.parentNode.replaceChild(elClone, el);

		app.fsMsg.querySelector('.fsm-footer').setAttribute('hidden', true);

		app.fsMsg.querySelector('.fsm-footer button.btnLeft').setAttribute('hidden', true);
		app.fsMsg.querySelector('.fsm-footer button.btnLeft').innerHTML = 'Action';
		app.fsMsg.querySelector('.fsm-footer button.btnLeft').style.background = '#1a73e8';

		app.fsMsg.querySelector('.fsm-footer button.btnRight').setAttribute('hidden', true);
		app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = 'Action';
		app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = '#e81a5d';
	};

	app.togglePopupDialog = function(visible = true) {
    if (visible) {
      app.popupBox.classList.add('dialog-container--visible');
    }
    else {
      app.popupBox.classList.remove('dialog-container--visible');
    }
  };

	app.showAboutDialog = function(e) {
		e.preventDefault();
		app.hideMenu();

		app.popupBox.querySelector('.dialog-title').innerHTML = app.appName;
		app.popupBox.querySelector('.dialog-body').innerHTML = 'Aplikasi ini adalah untuk kegunaan <i>Training</i> <b>Progressive Web App</b>.<br><br>Maklumat terkini akan dikemaskini dari semasa ke semasa.<br><br><span style="font-size: 70%;">Icon made by <b>Pixel perfect</b> from www.flaticon.com</span>';

		app.togglePopupDialog(true);
  };

	app.disableContent = function(target, bool = true) {
		var nodes = document.querySelector(target).getElementsByTagName('*');
		for(var i = 0; i < nodes.length; i++){
			nodes[i].disabled = bool;
		}

		if (bool)
			document.querySelector(target).classList.add('disabled');
		else
			document.querySelector(target).classList.remove('disabled');
	}

	// Boilerplate borrowed from https://www.npmjs.com/package/web-push#using-vapid-key-for-applicationserverkey
	app.urlBase64ToUint8Array = function(base64String) {
		const padding = '='.repeat((4 - base64String.length % 4) % 4);
		const base64 = (base64String + padding)
			.replace(/\-/g, '+')
			.replace(/_/g, '/');

		const rawData = window.atob(base64);
		const outputArray = new Uint8Array(rawData.length);

		for (let i = 0; i < rawData.length; ++i) {
			outputArray[i] = rawData.charCodeAt(i);
		}
		return outputArray;
	};

	app.registerPush = async function() {
		toast('Subcribed for push notification.');

		console.info('Registering push...');
		const subscription = await app.registration.pushManager.
			subscribe({
				userVisibleOnly: true,
				applicationServerKey: app.urlBase64ToUint8Array(app.publicVapidKey)
			});
		console.info('Push registered.');

		console.info('Sending initial push...');
		await fetch('https://api.afb.my/webpush', {
			method: 'POST',
			headers: {
				'content-type': 'application/json'
			},
			body: JSON.stringify({regtoken: app.pushAppName, clientid: subscription})
		})
		.then(function(response) {
			if (!response.ok) {
				localStorage.setItem("subWebPush", 0);
				document.querySelector('#toggle').checked = false;
				throw new Error('Bad status code from server.');
			}

			return response.json();
		})
		.then(function(responseData) {
			if (!(responseData.success)) {
				localStorage.setItem("subWebPush", 0);
				document.querySelector('#toggle').checked = false;
				throw new Error('Bad response from server.');
			}
			else {
				localStorage.setItem("subWebPush", 1);
				localStorage.setItem("subEntry", JSON.stringify(subscription));

			}
		});
		console.info('Respond received.');
	};

	app.unregisterPush = function() {
		toast('Push notification is cancelled.');

		app.registration.pushManager.getSubscription()
		.then(function(subscription) {
			if (subscription) {
				console.info('Unregister push...');
				fetch('https://api.afb.my/webpush/removeme', {
					method: 'DELETE',
					headers: {
						'content-type': 'application/json'
					},
					body: JSON.stringify({regtoken: app.pushAppName, clientid: subscription})
				})
				.then(function(response) {
					if (!response.ok) {
						throw new Error('Bad status code from server.');
					}

					return response.json();
				})
				.then(function(responseData) {
					if (!(responseData.success)) {
						throw new Error('Bad response from server.');
					}
					else {
						localStorage.setItem("subWebPush", 0);

						console.info('Unsubscribed from push notification.');
					}
				});

				return subscription.unsubscribe();
			}
			else {
				localStorage.setItem("subWebPush", 0);

				console.info('Subscription not found.');
			}

		})
		.catch(function(error) {
			throw new Error('Error unsubscribing', error);
		});
	};

	app.updateSubscriptionToTheServer = async function(subscription) {
		console.info('Updating subscription...');

		await fetch('https://api.afb.my/webpush/updateme', {
			method: 'POST',
			headers: {
				'content-type': 'application/json'
			},
			body: JSON.stringify({regtoken: app.pushAppName, clientid: subscription})
		})
		.then(function(response) {
			if (!response.ok) {
				localStorage.setItem("subWebPush", 0);
				document.querySelector('#toggle').checked = false;

				throw new Error('Bad status code from server.');
			}

			return response.json();
		})
		.then(function(responseData) {
			if (!(responseData.success)) {
				localStorage.setItem("subWebPush", 0);
				document.querySelector('#toggle').checked = false;

				throw new Error('Bad response from server.');
			}
			else {
				localStorage.setItem("subWebPush", 1);
				localStorage.setItem("subEntry", JSON.stringify(subscription));

				document.querySelector('#toggle').checked = true;
			}
		});
		console.info('Subscription updated.');
	};

	app.askPermission = function() {
		return new Promise(function(resolve, reject) {
			var permissionResult = Notification.requestPermission(function(result) {
				resolve(result);
			});

			if (permissionResult) {
				permissionResult.then(resolve, reject);
			}
		})
		.then(function(permissionResult) {
			if (permissionResult !== 'granted') {
				document.querySelector('#toggle').checked = false;
				throw new Error('We weren\'t granted permission.');
			}
			else {
				app.registerPush();
			}
		});
	};

	app.subWebPush = function() {
		//unsubscribe
		if (Notification.permission === "granted" && localStorage.getItem("subWebPush")==1) {
			app.unregisterPush();
		}
		else if (Notification.permission === "denied") {
			document.querySelector('#toggle').checked = false;
			toast("Please allow notification in your<br>browser's setting first.");
			console.info("Notifications permission has been blocked. Please allow notification in your browser's setting first.");
		}
		//requestPermission
		else {
			app.askPermission();
		}
	};

	app.installPromotion = function(show = true) {
		app.pwahomescreen.style.display = (show ? 'block' : 'none');
	};

	app.toFixedTwo = function(number, pad) {
    return "00000".substring((number + "").length, pad) + number;
  };

	app.isUrl = function(s) {
		var regexp = /^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
		return regexp.test(s.toLowerCase());
	};

  app.isLocalhost = function() {
		// https://stackoverflow.com/questions/53563619/exclude-index-html-from-service-worker-cache-in-create-react-app
		return Boolean(
			window.location.hostname === 'localhost' ||
			// [::1] is the IPv6 localhost address.
			window.location.hostname === '[::1]' ||
			// 127.0.0.1/8 is considered localhost for IPv4.
			window.location.hostname.match(
				/^127(?:\.(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)){3}$/
			)
		);
	};

	app.updateOnlineStatus = function() {
		if (navigator.onLine) {
			// handle online status
			console.info('online');

			document.getElementById('menuPush').classList.remove("disabled");
			document.getElementById('toggle').removeAttribute("disabled");

			document.querySelector('.header').style.filter = 'grayscale(0)';
			document.querySelector('.logo').style.filter = 'grayscale(0)';
		} else {
			// handle offline status
			console.info('offline');

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");

			document.querySelector('.header').style.filter = 'grayscale(1)';
			document.querySelector('.logo').style.filter = 'grayscale(1)';
		}
	};

	app.fullscreenMsg = function(msg, title = app.appName, obj = false) {
		app.fsMsg.querySelector('.fsm-title').innerHTML = title;
		app.fsMsg.querySelector('.fsm-body').innerHTML = msg;

		app.fsMsg.querySelector('.fsm-footer').removeAttribute('hidden');

		if (obj) {
			if (obj.right) {
				app.fsMsg.querySelector('.fsm-footer button.btnRight').removeAttribute('hidden');
				app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = obj.right.label;
				app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = obj.right.color ? obj.right.color : '#1a73e8';
				app.fsMsg.querySelector('.fsm-footer button.btnRight').addEventListener('click', obj.right.action ? obj.right.action : app.closeFullscreenMsg);
			}
			
			if (obj.left) {
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').removeAttribute('hidden');
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').innerHTML = obj.left.label;
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').style.background = obj.left.color ? obj.left.color : '#e81a5d';
				app.fsMsg.querySelector('.fsm-footer button.btnLeft').addEventListener('click', obj.left.action ? obj.left.action : app.closeFullscreenMsg);
			}
		}
		else {
			app.fsMsg.querySelector('.fsm-footer button.btnRight').removeAttribute('hidden');
			app.fsMsg.querySelector('.fsm-footer button.btnRight').innerHTML = 'OK';
			app.fsMsg.querySelector('.fsm-footer button.btnRight').style.background = '#1a73e8';
			app.fsMsg.querySelector('.fsm-footer button.btnRight').addEventListener('click', app.closeFullscreenMsg);
		}

		app.fsMsg.classList.add('fs-message--visible');
	};

	async function run() {

		app.registration = await navigator.serviceWorker.register('/sw.js', {scope: '/'})
		.then(async function(sw) {
			console.info('ServiceWorker registered: ', sw.scope);

			var isUpdate = false;
			// If this fires we should check if there's a new Service Worker
			// waiting to be activated. If so, ask the user to force refresh.
			if (sw.active)
				isUpdate = true;

			sw.onupdatefound = function(event) {
				// If an update is found the spec says that there is a new Service
				// Worker installing, so we should wait for that to complete then
				// show a notification to the user.
				sw.installing.onstatechange = function(event) {
					if (this.state === 'installed') {
						console.info("Service Worker Installed.");
						if (isUpdate) {
							app.fullscreenMsg(
								'New version is available!<br/>We need to reload this web app to update all changes.',
								app.appName,
								{right: {label: 'OK', action: app.reloadWebApp}}
							);
						}
						else {
							toast(app.appName + ' ready for offline use.');
						}
					}
					else {
						console.info("New Service Worker state:", this.state);
					}
				};
			};

			await sw.pushManager.getSubscription().then(function(sub) {
				if (sub === null) {
					// Update UI to ask user to register for Push
					//console.info('Not subscribed to push service!');
					localStorage.setItem("subWebPush", 0);
					document.querySelector('#toggle').checked = false;
				}
				else {
					// We have a subscription, update the database
					//console.info('Subscription object: ', sub);
					if (localStorage.getItem("subWebPush") == 0) {
						// insert subscription to the server
						app.updateSubscriptionToTheServer(sub);

					}
					else if (localStorage.getItem("subWebPush") == 1 && !localStorage.getItem("subEntry")) {
						// update changes subscription to the server
						app.updateSubscriptionToTheServer(sub);
					}
					else if (localStorage.getItem("subWebPush") == 1 && localStorage.getItem("subEntry") && sub.endpoint !== JSON.parse(localStorage.getItem("subEntry")).endpoint) {
						console.info("New: " + sub.endpoint);
						console.info("Old: " + JSON.parse(localStorage.getItem("subEntry")).endpoint);
						console.info('Subscription changed!');

						// update changes subscription to the server
						app.updateSubscriptionToTheServer(sub);
					}
				}
			});

			return sw;
		})
		.catch(function(err) {
			console.error('Unable to register service worker.', err);
		});
	};

	app.nextTick = function() {
		// run after registering Service Worker
		console.info("Running other functions after registering SW...");

		app.firstLoadFromHashIfAny();
	};

	app.firstLoadFromHashIfAny = function() {
		var v1 = app.getHashParam().hash;
		var v2 = document.querySelector("a[href='/" + v1 + "']");

		if (v2) 
			app.changeView('switch-'+v2.id, v2.innerHTML);
	};

	app.getState = function() {
		if (document.visibilityState === 'hidden') {
			return 'hidden';
		}
		if (document.hasFocus()) {
			return 'focused';
		}
		return 'not focused';
	};

	app.logStateChange = function(nextState) {
		var prevState = app.state;
		if (nextState !== prevState) {
			var timeBadge = new Date().toTimeString().split(' ')[0];
			console.info('' + timeBadge + ' State changed from ' + prevState + ' to ' + nextState + '.');

			app.state = nextState;
		}
	};

	app.onPageStateChange = function() {
		//app.logStateChange(app.getState())
	};

	app.getHashParam = function() {
		if (window.location.hash) {
			var tmp = window.location.hash.split('?')

			var result         = {};
					result['hash'] = tmp[0];

			if (tmp[1]) {
				tmp[1].split('&').reduce(function (result2, item) {
					var parts = item.split('=');
					result[parts[0]] = parts[1];
				}, {});
			}

			return result;
		}

		return { hash: null };
	};

	/*****************************************************************************
   *
   * Event listeners for UI elements
   *
   ****************************************************************************/
	
  document.getElementById('btnHome').addEventListener('click', function() {
    app.changeView();
  });

	document.getElementById('btnBackHome').addEventListener('click', function() {
    app.changeView();
  });

  document.getElementById('page0').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView();
	});

  document.getElementById('page1').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

	document.getElementById('page2').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

	document.getElementById('page3').addEventListener('click', function(e) {
		e.preventDefault();
		app.changeView('switch-'+this.id, this.innerHTML);
	});

  document.getElementById('menuAbout').addEventListener('click', app.showAboutDialog);

	app.popupBox.addEventListener('click', function() {
    app.togglePopupDialog(false);
  });

	app.toast.addEventListener('click', function(event) {
    if (event.target.classList.contains('clicktoreload'))
      document.location.reload();
  });

	document.getElementById('toggle').addEventListener('change', function() {
		if(this.checked) {
			app.subWebPush();
		}
		else {
			app.unregisterPush();
		}
	});

	document.getElementById('noinstallpwa').addEventListener('click', function() {
		app.installPromotion(false);
	});
	
	['pageshow', 'focus', 'blur', 'visibilitychange', 'resume'].forEach(function (type) {
		window.addEventListener(type, app.onPageStateChange, {capture: true});
	});

	// disable back function of the back button
	window.addEventListener('popstate', function() {
		history.pushState(null, document.title, location.href);
	});

  /*****************************************************************************
   *
   * Methods to update/refresh the UI
   *
   ****************************************************************************/

  app.hideMenu = function() {
    var menuElement = document.querySelector('.menu');
    var menuOverlayElement = document.querySelector('.menu__overlay');

    menuElement.style.transform = "translateX(-110%)";
    menuElement.classList.remove('menu--show');
    menuOverlayElement.classList.remove('menu__overlay--show');
    menuElement.addEventListener('transitionend', onTransitionEnd, false);
  };

  function onTransitionEnd() {
    var touchStartPoint;
    var menuElement = document.querySelector('.menu');
    var menuOverlayElement = document.querySelector('.menu__overlay');

    if (touchStartPoint < 10) {
      menuElement.style.transform = "translateX(0)";
      menuOverlayElement.classList.add('menu__overlay--show');
      menuElement.removeEventListener('transitionend', onTransitionEnd, false);
    }
  };

	var isTouchSupported = 'ontouchstart' in window;
  var evt = isTouchSupported ? 'touchend' : 'mouseup';

  // iOS
  document.ontouchmove = function(e) {
    e.preventDefault();
  };

  var scrollingDiv0 = document.getElementsByClassName('page0')[0];
  scrollingDiv0.addEventListener('touchmove', function(event) {
		event.stopPropagation();
  });

  var scrollingDiv1 = document.getElementsByClassName('page1')[0];
  scrollingDiv1.addEventListener('touchmove', function(event) {
    event.stopPropagation();
  });

  var scrollingDiv2 = document.getElementsByClassName('page2')[0];
  scrollingDiv2.addEventListener('touchmove', function(event) {
		event.stopPropagation();
  }); 

	var scrollingDiv3 = document.getElementsByClassName('page3')[0];
  scrollingDiv3.addEventListener('touchmove', function(event) {
    event.stopPropagation();
  });

  window.addEventListener('online', app.updateOnlineStatus);
  window.addEventListener('offline', app.updateOnlineStatus);

  /************************************************************************
   *
   * Code required to start the app
   *
   * NOTE: To simplify this codelab, we've used localStorage.
   *   localStorage is a synchronous API and has serious performance
   *   implications. It should not be used in production applications!
   *   Instead, check out IDB (https://www.npmjs.com/package/idb) or
   *   SimpleDB (https://gist.github.com/inexorabletash/c8069c042b734519680c)
   ************************************************************************/

	/** custom pwa install prompt **/
	var deferredPrompt;
	window.addEventListener('beforeinstallprompt', function(e) {
		// Prevent the mini-infobar from appearing on mobile
		e.preventDefault();
		// Stash the event so it can be triggered later.
		deferredPrompt = e;
		// Update UI notify the user they can install the PWA
		app.installPromotion(true);
	});

	app.buttonInstall.addEventListener('click', function(e) {
		// Show the install prompt
		deferredPrompt.prompt();
		// Wait for the user to respond to the prompt
		deferredPrompt.userChoice.then(function(choiceResult) {
			if (choiceResult.outcome === 'accepted') {
				app.reloadWebApp();
				console.info('User accepted the install prompt');
			} else {
				app.pwahomescreen.style.display = 'none';
				console.info('User dismissed the install prompt');
			}
			// Hide the app provided install promotion
			app.installPromotion(false);
		});
	});

	window.addEventListener('appinstalled', function() {
		// Hide the app provided install promotion
		app.installPromotion(false);
		// Log install to analytics
		console.info('installed to homescreen');
	});

	window.addEventListener('load', function() {
		console.group('[Starting App]');

		if (app.isLocalhost()) {
			// debugging
			document.querySelector('.header__title').addEventListener('click', function() {
				console.info(app.visibleEl);
			});
		}
		else {
			window.oncontextmenu = function(ev) {
				ev.preventDefault();
				ev.stopPropagation();
				return false;
			};
		}

		app.state = app.getState();

		console.info(app.isLocalhost() ? 'localhost' : 'internet');

		app.updateOnlineStatus();

		if (typeof(Storage) !== "undefined") {
			console.info("✔ 1) LocalStorage is supported.");
		}
		else {
			console.info("✘ 1) Your browser has no LocalStorage support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}

		if (!("Notification" in window)) {
			// Notification isn't supported on this browser, disable or hide UI.
			console.info("✘ 2) Your browser has no Notification support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}
		else {
			console.info("✔ 2) Notification is supported.");

			if (Notification.permission === "granted") {
				if (localStorage.getItem("subWebPush")==1)
					document.querySelector('#toggle').checked = true;
			}

		}

		if (!('PushManager' in window)) {
			// Push isn't supported on this browser, disable or hide UI.
			console.info("✘ 3) Your browser has no PushManager support.");

			document.getElementById('menuPush').classList.add("disabled");
			document.getElementById('toggle').setAttribute("disabled", "disabled");
		}
		else {
			console.info("✔ 3) PushManager is supported.");
		}

		if ("Notification" in window && "showTrigger" in Notification.prototype) {
			/* origin-trial - Notification Triggers supported */
			console.info("✔ 4) Notification Triggers is supported.");
		}
		else {
			console.info("✘ 4) Your browser has no Notification Triggers support.");
		}

		if (!('serviceWorker' in navigator)) {
			// Service Worker isn't supported on this browser, disable or hide UI.
			console.info("Service Worker isn't supported on this browser.");
		}
		else {
			console.info('Registering service worker...');

			run().then(app.nextTick);
		}

		if (app.isLoading) {
			app.spinner.setAttribute('hidden', true);

			app.isLoading = false;
		}

		console.groupEnd();

	});

})();
